/*  POETRY SCANNER:                                                  */
/*                                                                   */
/*     This program scans text to perform primitive text analysis.   */

list_of_articles = 'A AN THE'
list_of_preps    = 'AT BY FOR FROM IN OF TO WITH' 

big_words       = 0   ;   small_words  = 0
number_articles = 0   ;   number_preps = 0

do while lines('poetry.txt') > 0
   line_str = linein('poetry.txt')  /* read a line of poetry         */
   line_str = translate(line_str)   /* translate to upper-case       */
   line_str = translate(line_str,'      ','.,!:;"') /* remove punc.  */
   call lineout ,space(line_str)    /* display converted input line  */
                                   
   do j=1 to words(line_str)        /* do while a word to process    */
      if wordlength(line_str,j) >= 5 then
          big_words = big_words + 1             /* count big words   */
      else
          small_words = small_words + 1         /* count small words */
      word_to_analyze = word(line_str,j)        /* get the word      */
      if wordpos(word_to_analyze,list_of_articles) > 0 then
          number_articles = number_articles + 1 /* count the articles*/
      if wordpos(word_to_analyze,list_of_preps) > 0 then
          number_preps = number_preps + 1       /* count prep phrases*/
   end
end                
say
say 'Ratio long/short words:  ' (big_words/small_words)
say 'Number of articles:    ' number_articles
say 'Number of prepositions:' number_preps
say 'Ratio of preps/total words:' (number_preps/(big_words+small_words))
